Ext.namespace('dSA', 'dSA.actions', 'dSA.util', 'dSA.dialogs',
              'dSA.actions.presence');

dSA.actions.presence.UpdateProgress = function(task_id, p)
{
    if (dSA.actions.presence.TaskID === 0)
    {
        return;
    }

    dSA.functions.GetCurrentTask(
        function(success, data)
        {
            if (success === false)
            {
                p.getDialog().setIconClass('dSA_DevicePresenceTitle');
                p.hide();
                dSA.actions.presence.TaskID = 0;
                return;
            }

            if (data.id !== task_id)
            {
                p.updateProgress(1, '100%');
                p.getDialog().setIconClass('dSA_DevicePresenceTitle');
                dSA.actions.presence.TaskID = 0;
                p.hide.defer(2000, p);
                return;
            } 
            else
            {
                p.updateProgress(data.progress * 0.01, data.progress + '%');
                if (data.progress === 100)
                {
                    p.getDialog().setIconClass('dSA_DevicePresenceTitle');
                    dSA.actions.presence.TaskID = 0;
                    p.hide.defer(2000, p);
                    return;
                }
            }

            dSA.actions.presence.UpdateProgress.defer(2000, this, [task_id, p]);
        }
    );
};

dSA.actions.presence.Test = function(dsid, name, interval)
{
    dSA.actions.presence.TaskID = 0;

    dSA.functions.CheckDevicePresence(dsid, 2000,
        function(success, task_id)
        {
            if (success !== true)
            {
                return;
            }
            
            dSA.actions.presence.TaskID = task_id;

            var p = Ext.MessageBox.show({
                title: dSA._("Checking device presence") + '...',
                msg: dSA._("Checking device presence on dSM") +
                     ' &quot;' + dSA.util.getName(name) + '&quot; ' +
                     '(' + dSA.util.shortDSID(dsid) + ')',
                iconCls: 'loading-indicator-small',
                progressText: '0%',
                width: 400,
                progress: true,
                buttons: { cancel: true },
                fn: function() 
                { 
                    dSA.functions.AbortTask(task_id);
                    dSA.actions.presence.TaskID = 0;
                    p.getDialog().setIconClass('dSA_DevicePresenceTitle');
                    p.hide();
                },
                closable:false
            }); 

            dSA.actions.presence.UpdateProgress(task_id, p);
        }
    );
};
