Ext.namespace('dSA', 'dSA.functions', 'dSA.actions',
              'dSA.actions.transmission', 'dSA.actions.presence');

dSA.ReactorImpl = Ext.extend(Ext.util.Observable, {
    constructor: function(config) {
        this.addEvents(
            'checktransmissionquality', // dSM dSID, dSM name, mask element
            'reregisterdevices',        // dSM dSID
            'checkdevicepresence',      // dSM dSID, dSM name, interval
            'blinkdsmled'               // dSM dSID
        );
        dSA.ReactorImpl.superclass.constructor.call(this, config);
    }
});

dSA.Reactor = (function() {
    return new dSA.ReactorImpl();
})();

dSA.Reactor.on('reregisterdevices', dSA.functions.ReregisterDevices);
dSA.Reactor.on('checktransmissionquality', dSA.actions.transmission.Test);
dSA.Reactor.on('checkdevicepresence', dSA.actions.presence.Test);
dSA.Reactor.on('blinkdsmled', dSA.functions.BlinkLEDonDSM);
